
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MessagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.create(
            {
                id: data.id || undefined,
        
        subject: data.subject
        ||
        null
            ,
            
        body: data.body
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await messages.setMailbox( data.mailbox || null, {
            transaction,
        });
        
        await messages.setFrom_user( data.from_user || null, {
            transaction,
        });
        
        await messages.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.messages.getTableName(),
                belongsToColumn: 'attachment_files',
                belongsToId: messages.id,
            },
            data.attachment_files,
            options,
        );
        

        return messages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const messagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                subject: item.subject
            ||
            null
            ,
            
                body: item.body
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const messages = await db.messages.bulkCreate(messagesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < messages.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.messages.getTableName(),
                    belongsToColumn: 'attachment_files',
                    belongsToId: messages[i].id,
                },
                data[i].attachment_files,
                options,
            );
        }
        

        return messages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const messages = await db.messages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.subject !== undefined) updatePayload.subject = data.subject;
        
        
        if (data.body !== undefined) updatePayload.body = data.body;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await messages.update(updatePayload, {transaction});

        
        
        if (data.mailbox !== undefined) {
            await messages.setMailbox(
              
              data.mailbox,
              
              { transaction }
            );
        }
        
        if (data.from_user !== undefined) {
            await messages.setFrom_user(
              
              data.from_user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await messages.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.messages.getTableName(),
                belongsToColumn: 'attachment_files',
                belongsToId: messages.id,
            },
            data.attachment_files,
            options,
        );
        

        return messages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of messages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of messages) {
                await record.destroy({transaction});
            }
        });


        return messages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findByPk(id, options);

        await messages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await messages.destroy({
            transaction
        });

        return messages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findOne(
            { where },
            { transaction },
        );

        if (!messages) {
            return messages;
        }

        const output = messages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.mailbox = await messages.getMailbox({
            transaction
        });
        
        
        output.from_user = await messages.getFrom_user({
            transaction
        });
        
        
        output.attachment_files = await messages.getAttachment_files({
            transaction
        });
        
        
        output.organizations = await messages.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.private_mailboxes,
        as: 'mailbox',
        
        where: filter.mailbox ? {
          [Op.or]: [
            { id: { [Op.in]: filter.mailbox.split('|').map(term => Utils.uuid(term)) } },
            {
              public_label: {
                [Op.or]: filter.mailbox.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'from_user',
        
        where: filter.from_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.from_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.from_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachment_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.subject) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'messages',
                        'subject',
                        filter.subject,
                    ),
                };
            }
            
            if (filter.body) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'messages',
                        'body',
                        filter.body,
                    ),
                };
            }
            

            
            

            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.messages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'messages',
                        'subject',
                        query,
                    ),
                ],
            };
        }

        const records = await db.messages.findAll({
            attributes: [ 'id', 'subject' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['subject', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.subject,
        }));
    }

    
};

